import 'package:flutter/foundation.dart';
import 'package:flutter/widgets.dart';
import 'package:wowit/Interface/iWatting.dart';
import 'package:wowit/common.dart';
import 'package:wowit/sqlService.dart';

import 'methods.dart';

class Message {
//get message by key
  static String getMessage(String key) {
    Map mapMessage = Common.mapMessageData;

    if (mapMessage.containsKey(key)) {
      return mapMessage[key];
    } else {
      //try again with upper case
      key = key.toUpperCase();
      if (mapMessage.containsKey(key)) {
        return mapMessage[key];
      }
    }
    return key;
  }

  static void setLanguage(int languageCode) {
    Common.languageId = languageCode;
  }

  static Future<void> getMessageSQL(dynamic prefs,VoidCallback  showWatting, VoidCallback  hideWatting,Map<String, String> defaultMessage , {bool reload = false}) async {
    if (!kReleaseMode) {
      print('getMessageSQL app run debug not get message from server');
    } else {
      final pattern =
          "[(=-|"; //cong key kho vao, de dam bao khong gap ky tu user su dung.
     
      int language = Common.languageId ?? 1;
      Map<String, String> valueMessage = Map();
      if (prefs.getStringList('language') == null || reload) {
        if (reload) {
          showWatting.call();
        }
        List<String> listLanguage = [];
        var data = await SQLService.execute('getMessage',
            params: {'@languageId': language});
        if (Methods.getList(data, 'language').length > 200) {
          if (Common.uid > 0) {
            SQLService.execute('sp_setHasMapMessage',
                params: {'@uid': Common.uid});
          }

          for (var item in Methods.getList(data, 'language')) {
            listLanguage.add(Methods.getString(item, 'messageId') +
                pattern +
                Methods.getString(item, 'message'));
          }
          if (prefs.getStringList('language') != null) {
            prefs.remove('language');
          }
          prefs.setStringList('language', listLanguage);
        }
        for (var itemlist in prefs.getStringList('language')) {
          var convert = itemlist.split(pattern);
          if (convert != null && convert.length > 1) {
            valueMessage[convert[0]] = convert[1];
          }
        }
      } else {
        valueMessage = defaultMessage;
      }
      Common.initWowIT(
        valueMessage,
        Common.url_host,
      );
      if (reload) {
        hideWatting.call();
      }
    }
  }
}
